﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace UltraTreePrintDocument
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            InitTree();
            ultraTreePrintDocument1.BeginPrint += ultraTreePrintDocument1_BeginPrint;
        }

        private void InitTree()
        {
            if (ultraTree1.ImageList == null)
            {
                ultraTree1.ImageList = new ImageList();
                ultraTree1.ImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
                ultraTree1.ImageList.ImageSize = new System.Drawing.Size(16, 16);
                ultraTree1.ImageList.TransparentColor = System.Drawing.Color.Transparent;
                System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
                foreach (var imageName in ImageListName)
                {
                    ultraTree1.ImageList.Images.Add((Bitmap)(resources.GetObject(imageName)));
                }
                AddImageToNode(ultraTree1.Nodes[0]);
            }
        }

        private List<string> ImageListName = new List<string>() 
        { 
            "ultraTreeNode1.LeftImages"
        };



        private void AddImageToNode(UltraTreeNode treeNode)
        {
            treeNode.LeftImages.Clear();
            //************************************************************
            //**********  FIRST in the program => No image printing *******
            //************************************************************
            treeNode.LeftImages.Add(ImageListName.FindIndex(k => k == "ultraTreeNode1.LeftImages"));

            //************************************************************
            //**********  NOW in the program => The image is printing   ***
            //************************************************************
            //treeNode.LeftImages.Add(ultraTree1.ImageList.Images[(ImageListName.FindIndex(k => k == "ultraTreeNode1.LeftImages"))]);
        }


        void ultraTreePrintDocument1_BeginPrint(object sender, System.Drawing.Printing.PrintEventArgs e)
        {
            //throw new NotImplementedException();
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            ultraPrintPreviewDialog1.Document = ultraTreePrintDocument1;
            ultraPrintPreviewDialog1.ShowDialog();
        }
    }
}
